/* 
 *    frame.h
 *
 *	Copyright (C) Vivien Chappelier - 2000
 *
 *  This file is part of fame, a free MPEG encoder.
 *	
 *  fame is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  fame is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */

#ifndef __FRAME_H
#define __FRAME_H

#include <common.h>

/* Frame color formats */
#define FRAME_FORMAT_YUV9    1
#define FRAME_FORMAT_YUV12   2
#define FRAME_FORMAT_YUYV    3

typedef byte frameformat_t;

struct VideoFrame
{
        word sx;
        word sy;
        frameformat_t format;
        byte * bitmap;
};

struct AudioFrame
{
        word frequency;
        word length;
        byte bits;
        byte * wave;
};

#endif
