/* 
 *    grabber.h
 *
 *	Copyright (C) Vivien Chappelier - 2000
 *
 *  This file is part of fame, a free MPEG encoder.
 *	
 *  fame is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  fame is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */

#ifndef _GRABBER_H
#define _GRABBER_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <signal.h>
#include <endian.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/mman.h>

#include <asm/types.h>
#include <linux/videodev.h>

#include <frame.h>
#include "video4linux/bgrab.h"
//#include "xutil.h"

class Grabber
{
 public:
  Grabber(char * dev);
  ~Grabber();

  void Open();
  void Tune(long freq);
  bool SetFrameParameters(tunermode_t mode, frameformat_t format, int width, int height);
  void SetFrequency(double frequency);
  void SetAudio(int state);
  void PrintInfos();

  void Capture();

  VideoFrame frame;

 private:

  char *device;

};

#endif
