/* 
 *    module.cpp
 *
 *	Copyright (C) Vivien Chappelier - 2000
 *
 *  This file is part of fame, a free MPEG encoder.
 *	
 *  fame is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  fame is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */

#ifndef __MODULE_H
#define __MODULE_H

typedef void * (* module_init_f)(int argc, char *argv[]);
typedef void (* module_close_f)(void * context);

class ModuleList
{
 public:
  ModuleList(char const * path);
  ~ModuleList();

  char const * Next();

 private:
  int count;
  char **module_list;
};

class ModulePath
{
 public:
  ModulePath(char * env[]);
  ~ModulePath();

  char const * Path() const;
 private:
  char * path;
};

class Module
{
 public:
  Module(char const * name, char const * args);
  virtual ~Module();

  char const * identify();
  bool status();

 protected:
  void * get_symbol(char const * symbol);

  void * module;
  void * context;
  char * name;
  bool good;
};

#endif
