#ifndef __SOCKMCAST_H
#define __SOCKMCAST_H

#include <sockinet.h>

class sockmcastbuf : public sockinetbuf {  
  struct ip_mreq mreq;
  bool membership;
public:
    
  sockmcastbuf (const sockbuf& si) : sockinetbuf(si) { membership = false; }
  sockmcastbuf (const sockinetbuf& si) : sockinetbuf (si) { membership = false; }
  sockmcastbuf (const sockmcastbuf& si) : sockinetbuf (si) { membership = false; }
  sockmcastbuf (sockbuf::type ty, int proto=0) : sockinetbuf(ty, proto) { membership = false; }
  virtual ~sockmcastbuf();

  int bind (char const * address, int port);
  int bind (int address, int port);
  virtual int bind (sockAddr & sa);

  bool is_address_multicast(sockAddr const & sa);
};

class isockmcast: public isockinet
{
public:
    			isockmcast (const sockbuf& sb);
    			isockmcast (int proto=0);
};

class osockmcast: public osockinet
{
public:
    			osockmcast (const sockbuf& sb);
    			osockmcast (int proto=0);
};

class iosockmcast: public iosockinet
{
public:
    			iosockmcast (const sockbuf& sb);
    			iosockmcast (int proto=0);
};


#endif
