/* 
 *    system.cpp
 *
 *	Copyright (C) Vivien Chappelier - 2000
 *
 *  This file is part of fame, a free MPEG encoder.
 *	
 *  fame is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  fame is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */

#include "system.h"

#include <stdio.h>

/* Extern asm functions for bitwise i/o */
extern "C" void __CDECL BITWRITE(Bitbuffer *, unsigned int, unsigned int);
extern "C" void __CDECL BITRESET(Bitbuffer *, void);

void WriteSequenceHeader(ostream & out, dword sx, dword sy, int bitrate);
void WriteSequenceEnder(ostream & out);

Bitbuffer::Bitbuffer(int nbytes)
{
  nbits = 0;
  data = new byte[nbytes];
  for(register int i = 0; i < nbytes; i++)
    data[i] = 0;
}

Bitbuffer::~Bitbuffer()
{
  delete data;
}

#if 0
MpegVideoStream::MpegVideoStream()
{
  time_set = false;
  time_zero = 0;
  frames = 0;
  stream_start = 0;
}

MpegVideoStream::~MpegVideoStream()
{
}

void MpegVideoStream::StartSequence(ostream & out, int16 sx_, int16 sy_)
{
  sx = sx_;
  sy = sy_;

  /* WARNING : bitrate cannot be determined and is set arbitrarly */
  /*           anyway, most decoders don't care about the bitrate */
  /*           specified in the sequence header                   */
  WriteSequenceHeader(out, sx, sy, 4000);
}

void MpegVideoStream::EndSequence(ostream & out)
{

  /* This code was meant to correct bitrate after the sequence has been  */
  /* written. However, this cannot work on network streams (cannot seek) */

/*
  int32 bitrate;
  int32 time;
  streampos current_pos;
  
  time = (timer->GetCount() - time_zero);

  if(time)
  {
    bitrate = out.tellp() - stream_start;
    time *= 50;
    time /= timer->GetBase(); 
    bitrate /= time;
  }
  else
  {
    bitrate = 0;
    debug.OutputString("Bitrate is null! \n");
  }   
    
  current_pos = out.tellp();
  out.seekp(stream_start);
  WriteSequenceHeader(out, sx, sy, bitrate);
  out.seekp(current_pos);
*/

  WriteSequenceEnder(out);
}

int32 MpegVideoStream::InsertFrame(ostream & out, void * frame, int32 size_)
{
        out.write((byte *) frame, size_);
        frames ++;
        
        return(frames);
}
#endif
