;------------------------------------------------------------------------------
;	Fast Assembly MPEG Encoder
;------------------------------------------------------------------------------
; mmx.nas:
;	MMX specific functions 
;
;------------------------------------------------------------------------------
;
;	Copyright (C) 1999-2000 Vivien Chappelier
;
; *  This program is free software; you can redistribute it and/or modify
; *  it under the terms of the GNU General Public Licensse as published by
; *  the Free Software Foundation; either version 2 of the License, or
; *  (at your option) any later version.
; *
; *  This program is distributed in the hope that it will be useful,
; *  but WITHOUT ANY WARRANTY; without even the implied warranty of
; *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; *  GNU General Public License for more details.
; *
; *  You should have received a copy of the GNU General Public License
; *  along with this program; if not, write to the Free Software
; *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;
;------------------------------------------------------------------------------

; Macro definitions for portability
	
%macro cglobal 1 
       global _%1 
%define %1 _%1 
%endmacro

%macro cextern 1 
          extern _%1 
%define %1 _%1 
%endmacro

%ifdef _WIN32_
%define public cglobal
%endif

%ifdef _LINUX_
%define public global
%endif

section .data

	flags dd 0

; /////////////////////////////////////////////////////////////////////////////
; //                         	     CODE                                    //
; /////////////////////////////////////////////////////////////////////////////
	
section .text

        ; Stop using MMX instructions and restore the floating point
        public MMX_END
	public MMX_DETECT

align 16
MMX_DETECT:
        pushfd
        pop eax

        mov ecx, eax

        xor eax, 040000h
        push eax

        popfd
        pushfd

        pop eax
        xor eax,ecx
        jz .exit   		; Processor is 386

        push ecx
        popfd

        mov eax, ecx
        xor eax, 200000h

        push eax
        popfd
        pushfd

        pop eax
        xor eax, ecx
        je .exit

        pusha

        mov eax, 1
        cpuid

        mov [flags], edx

        popa

        mov eax, [flags]
	and eax, 800000h
	shr eax, 23
.exit: 
        ret

; *****************************************************************************
; * MMX_END function			                                      *
; *****************************************************************************
; * C prototype:							      *
; *	void MMX_END(void);						      *
; *                                                                           *
; * Function : Release MMX to allow the use of floating point operations      *
; *****************************************************************************

align 16
MMX_END:
        emms
        ret

