/* 
 *    input.h
 *
 *	Copyright (C) Vivien Chappelier - 2000
 *
 *  This file is part of fame, a free MPEG encoder.
 *	
 *  fame is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  fame is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */

#ifndef _VIDEO_H
#define _VIDEO_H

#include <frame.h>
#include <module.h>
#include <iostream.h>


typedef void (* video_callback_f)(void * data, int size);

typedef void (* video_set_callback_f)(void * context, video_callback_f callback);
typedef void (* video_encode_frame_f)(void * context, VideoFrame * frame);

class VideoModule : public Module
{
 public:
  VideoModule(char const * filename, char const * args);
  
  inline void EncodeFrame(VideoFrame * frame) { if(encode_frame) encode_frame(context, frame); };
  inline void SetCallback(video_callback_f callback) { if(set_callback) set_callback(context, callback); };

 private:
  video_encode_frame_f encode_frame;
  video_set_callback_f set_callback;
};

#endif
